//+------------------------------------------------------------------+
//|                                               100 pips a day.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern int     EntrySignal    = 1;
extern int     timeframe      = 1;
extern double  stopLoss       = 1000; 
extern double  lTakeProfit    = 20;
extern double  sTakeProfit    = 15;
extern double  lTrailingStop  = 10;
extern double  sTrailingStop  = 10;
extern color   clOpenBuy      = Blue;
extern color   clCloseBuy     = Aqua;
extern color   clOpenSell     = Red;
extern color   clCloseSell    = Violet;
extern color   clModiBuy      = Blue;
extern color   clModiSell     = Red;
extern string  Name_Prefix    = "100 pips New";
extern int     Slippage       = 0;
extern bool    UseSound       = true;
extern string  NameFileSound  = "shotgun.wav";
extern double  Lots           = 0.1;
extern int     MaxOrders      = 20;

datetime prevBarTime;
string Expert_Comment;
int init(){ 
   prevBarTime = Time[0];
   Expert_Comment = Name_Prefix + '_' + EntrySignal;
   return(0);
}

int deinit(){return(0);}

int start(){
   if(Bars<100)   {Print("bars less than 100");return(0);}
   if(lTakeProfit<10){Print("TakeProfit less than 10");return(0);}
   if(sTakeProfit<10){Print("TakeProfit less than 10");return(0);}
   
   if (prevBarTime == Time[0]) { return(0); }
   prevBarTime = Time[0];
   if(timeframe==0) {timeframe=Period();}

   if(AccountFreeMargin()<(1000*Lots)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);  }
      
   if(AllowEntry())  {
   	double diClose=iClose(Symbol(),timeframe,0);
	   double diMA1=iMA(Symbol(),timeframe,7,0,MODE_SMA,PRICE_OPEN,0);
   	double diMA2=iMA(Symbol(),timeframe,6,0,MODE_SMA,PRICE_OPEN,0);
		if (EntrySignal == 1) {
      	if (diClose<diMA1) { OpenBuy(); return(0); }
      	if (diClose>diMA2) { OpenSell(); return(0); }
		}
		if (EntrySignal == 2) {
      	if (diClose>diMA1) { OpenBuy(); return(0); }
      	if (diClose<diMA2) { OpenSell(); return(0); }
		}
		if (EntrySignal == 3) {
			double diSAR=iSAR(Symbol(),timeframe,0.02,0.2,0);
			if (diClose>diSAR) { OpenBuy(); return(0); }
      	if (diClose<diSAR) { OpenSell(); return(0); }
		}
	}
   
	CheckOrders();
   TrailingPositionsBuy(lTrailingStop);
   TrailingPositionsSell(sTrailingStop);
   return (0);
}

// - - - - - - FUNCTIONS - - - - - - -
// inverse == true for TakeProfit
double GetDelta(bool inverse, double sl, double bidDelta, double askDelta) {
	int type = OrderType();
	double result;
	if (inverse) { type = OP_BUY + OP_SELL - type; }
	if (type == OP_BUY) {
		result = OrderOpenPrice() - Point*sl;
		if (bidDelta > OrderOpenPrice()) {
			result = bidDelta;
		}
	} else {
		result = OrderOpenPrice() + Point*sl;
		if (askDelta < OrderOpenPrice()) {
			result = askDelta;
		}
	}
	return(NormalizeDouble(result, Digits));
}
 
void CheckOrders() {
	double ldStop, ldTake, takeProfit;
	double stopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL) * Point;
	double lDelta = MathMax(lTrailingStop*Point, stopLevel);
	double sDelta = MathMax(sTrailingStop*Point, stopLevel);
   for(int i=0;i<OrdersTotal();i++) { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if((OrderSymbol()!=Symbol()) || (OrderComment()!=Expert_Comment)) { continue; }
		if (OrderStopLoss() == 0) {
			ldStop = GetDelta(false, stopLoss, Bid - lDelta, Ask + sDelta);
			OrderModify(OrderTicket(), OrderOpenPrice(), ldStop, OrderTakeProfit(), 0);
		}
		if (OrderTakeProfit() == 0) {
		   takeProfit = sTakeProfit;
		   if (OrderType() == OP_BUY) { takeProfit = lTakeProfit; } 
			ldTake = GetDelta(true, takeProfit, Bid - stopLevel, Ask + stopLevel);
			OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), ldTake, 0);
		}
	}
}

bool AllowEntry()   {
   int count = MaxOrders;
   for(int i=0;i<OrdersTotal(); i++)  {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderComment()==Expert_Comment) { count--; }
   }
   if (count > 0) { return(true); } 
   return(false);
}

void TrailingPositionsBuy(int trailingStop) { 
   for(int i=0;i<OrdersTotal();i++) { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderComment()==Expert_Comment) { 
            if(OrderType()==OP_BUY) { 
               if(Bid-OrderOpenPrice()>trailingStop*Point) { 
                  if(OrderStopLoss()<Bid-trailingStop*Point || OrderStopLoss()==0)   {
                     ModifyStopLoss(Bid-trailingStop*Point); }}}}}} 

void TrailingPositionsSell(int trailingStop) { 
   for(int i=0;i<OrdersTotal();i++) { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderComment()==Expert_Comment) { 
            if(OrderType()==OP_SELL) { 
               if(OrderOpenPrice()-Ask>trailingStop*Point) { 
                  if(OrderStopLoss()>Ask+trailingStop*Point || OrderStopLoss()==0)  {  
                     ModifyStopLoss(Ask+trailingStop*Point);}}}}}} 
 
void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,0); 
   if (fm && UseSound) PlaySound(NameFileSound); 
} 

void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = Ask-Point*stopLoss; 
   ldTake = NormalizeDouble(GetTakeProfitBuy(),Digits); 
   lsComm = GetCommentForOrder(); 
   int ticket = OrderSend(Symbol(),OP_BUY,ldLot,NormalizeDouble(Ask,Digits),Slippage,0,0,lsComm,0,0,clOpenBuy); 
   if (ticket < 0) {
      Print("Error at Buy: ", GetLastError(), ", lots: ", ldLot, ", ldStop: ", ldStop, ", ldTake: ", ldTake, ", lsComm: ", lsComm);
      return;
   }
   if (!OrderModify(OrderTicket(), OrderOpenPrice(), ldStop, ldTake, 0, clOpenBuy)) {
      Print("Error at BuyModify: ", GetLastError(), ", lots: ", ldLot, ", ldStop: ", ldStop, ", ldTake: ", ldTake, ", lsComm: ", lsComm);
      return;
   }
   if (UseSound) PlaySound(NameFileSound);
}
 
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = Bid+Point*stopLoss; 
   ldTake = NormalizeDouble(GetTakeProfitSell(),Digits); 
   lsComm = GetCommentForOrder(); 
   int ticket = OrderSend(Symbol(),OP_SELL,ldLot,NormalizeDouble(Bid,Digits),Slippage,0,0,lsComm,0,0,clOpenSell); 
   if (ticket < 0) {
      Print("Error at Buy: ", GetLastError(), ", lots: ", ldLot, ", ldStop: ", ldStop, ", ldTake: ", ldTake, ", lsComm: ", lsComm);
      return;
   }
   if (!OrderModify(OrderTicket(), OrderOpenPrice(), ldStop, ldTake, 0, clOpenSell)) {
      Print("Error at BuyModify: ", GetLastError(), ", lots: ", ldLot, ", ldStop: ", ldStop, ", ldTake: ", ldTake, ", lsComm: ", lsComm);
      return;
   }
   if (UseSound) PlaySound(NameFileSound);
}
 
string GetCommentForOrder() { return(Expert_Comment); } 
double GetSizeLot() { return(Lots); } 
double GetTakeProfitBuy() { return(Ask+lTakeProfit*Point); } 
double GetTakeProfitSell() { return(Bid-sTakeProfit*Point); } 
